
angular.module('manageProtocols', ['ngResource'])
.controller('ExistingProtocolsController', function($scope, $resource) {
  var existingProtocolsResource = $resource(getExistingProtocolsUrl + '/:id', {id: '@_id'}, {'update': {method: 'PUT' }});
  $scope.importProtocol = function() {
    if(confirmProtocolSaved(this)){
      $('#importFiles').trigger('click');
    }
  };
  $scope.loadExistingProtocols = function() {
    existingProtocolsResource.query(function(data){
      $scope.protocols = data;
    }, errorMessage);
  };
  $scope.loadExistingProtocols();
  $scope.editProtocol = function(e) {
    var pid = e.target.value;
    if(!pid){
      pid = $(e.target).parent()[0].value;
    }
    window.location = xnatUri+'/app/template/EditProtocol.vm?protocolId='+pid;
  };
}).controller('NewProtocolsController', ['$scope', function($scope) {
  $scope.launchWizard = function() {
    xmodal.open({
      title: 'Define Protocol',
      content: '<label for="protocolName" class="protocolNameLabel">PROTOCOL NAME (REQUIRED)</label><input id="protocolName" name="protocolName" class="protocolNameField"/>',
      height: 200,
      width: 450,
      buttons: {
        save: {
          label: 'Save and Continue',
          isDefault: true,
          close: false,
          action: function(obj){
            var pname = $('#protocolName').val().trim();
            if($scope.protocolNameValidation(pname)){
              xmodal.close(obj.__modal);
              window.location = xnatUri+'/app/template/EditProtocol.vm?protocolName='+pname;
            } else {
              xmodal.message('Protocol Name Invalid', 'Please supply a valid protocol name.');
            }
          }
        }
      }
    });
  };
  $scope.protocolNameValidation = function(pname) {
    if(!pname){
      return false;
    } else if(false /*some regex stuff*/ ){
      return false;
    }
    return true;
  };
}]);



angular.module('editProtocol', ['ngResource'])
.controller('EditProtocolController', function($scope, $resource) {
  $scope.protocol = {name:'test'};
  var protocolResource = $resource(protocolUrl + '/:id', {id: '@_id'}, {'update': {method: 'PUT' }});
  $scope.loadExistingProtocol = function() {
    protocolResource.query(function(data){
      $scope.protocols = data;
    }, errorMessage);
  };
  $scope.loadExistingProtocol();
  $scope.editProtocol = function(e) {
    var pid = e.target.value;
    if(!pid){
      pid = $(e.target).parent()[0].value;
    }
    window.location = xnatUri+'/app/template/EditProtocol.vm?protocolId='+pid;
  };
});





function errorMessage(err) {
  console.log('ERROR:' + err);
  xModalMessage('ERROR', err);
};

function changeProtocol(event){
  if(confirmProtocolSaved(changeProtocol)){
    selectedProtocol = $('#existingProtocols').val();
    if(selectedProtocol){
      pWizDef.show();
      loadProtocol();
      $('#deleteProtocolBtn').removeAttr('disabled');
      $('#exportProtocolBtn').removeAttr('disabled');
    }
  }
};

function previousStep(){
  var prev = protTabs.get('activeIndex') - 1;
  if(prev >= 0) {
    protTabs.set('activeIndex', prev);
  }
  manageWizardButtons(prev);
};
function nextStep(){
  var next = protTabs.get('activeIndex') + 1;
  if(next < protTabs.get('tabs').length) {
    protTabs.set('activeIndex', next);
  }
  manageWizardButtons(next);
};
function finishStep(){
  saveProtocol(null, function(){
    xModalMessage('Protocol Saved', protocol.name+' saved successfully!');
    setTimeout(function(){
      //...after successful save...
      resetProtocolFields();    // ...clear the page and refresh the Existing Protocols list
      resetProtocolObject();
      pWizDef.hide();
      initializeExistingProtocols();
    }, 1000);
  });
};
function saveProtocolStep(){
  saveProtocol(
    null,
    function(){
      xModalMessage('Protocol Saved', protocol.name+' saved.');
      initializeExistingProtocols();
    }
  );
};

function manageWizardButtons(step){
  if(step>0){
    $('.wizardStepPrevious').removeAttr('disabled');
  } else {
    $('.wizardStepPrevious').attr('disabled', 'disabled');
  }
  if(step == protTabs.get('tabs').length - 1){
    $('.wizardStepNext').hide();
    $('.wizardStepFinish').show();
  } else {
    $('.wizardStepNext').show();
    $('.wizardStepFinish').hide();
  }
}

/*
function initializeExistingProtocols() {
  try{
    YAHOO.util.Connect.asyncRequest('GET', getExistingProtocolsUrl+'?'+noCache(), {
      success:function (o) {
        try {
          protocols = jq.parseJSON(o.responseText);
          populateExistingProtocols(protocols);
        } catch (e) {
          xModalMessage('ERROR: '+o.status, 'Failed to parse protocol.<br/><br/>'+e.message);
        }
      },
      failure:function (o) {
        handleProtocolError(o);
      },
      argument:this
    });
  } catch (e) {
    xModalMessage('ERROR: Failed to load protocol.', e.message);
  }
};
*/

function handleFileSelect(fileInputElement){
  if(checkFileAPISupport()){
    var output = [];
    for(var i = 0, f; f = fileInputElement.files[i]; i++) {
      output.push('<li><strong>', f.name, '</strong> - ',
                  f.size, ' bytes, last modified: ',
                  f.lastModifiedDate ? f.lastModifiedDate.toLocaleDateString() : 'n/a',
                  '</li>');
      importProtocol(f);
    }
    $('#fileList').html('<div style="font-weight:bold;">Importing...</div><ul>'+output.join('')+'</ul>');
    setTimeout(function(){$('#fileList').empty();}, 5000);
  }
};

function importProtocol(f){
  var reader = new FileReader();
  reader.onload=(function(file) {
    return function(e){
      var importedProtocol = e.target.result;
      try{
        importedProtocol = JSON.parse(importedProtocol);
        if(importedProtocol.protocol){
          importedProtocol = importedProtocol.protocol;
        }
        delete importedProtocol.protocolId;
        saveProtocol(importedProtocol, function() {
          xModalMessage('Protocol Saved', importedProtocol.name + ' imported successfully.');
          //initializeExistingProtocols();
          $scope.loadExistingProtocols();
          // TODO: if(lastFileToImport) { $('#existingProtocols').val(null); initializeExistingProtocols(); }
        });
      } catch (e) {
        xModalMessage('ERROR: Invalid JSON', 'Failed to parse protocol file.<br/><br/>'+e.message);
        $('#fileList').empty();
      }
    };
  })(f);
  reader.readAsText(f);
};